<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import {
  CTA as SolutionsCallToAction,
  CopyMedia,
  Table as SlpTable,
  Copy,
  LinkCards,
  NextStep,
  TabsMenu,
  FeaturedMedia,
  PullQuote,
  CopyForm,
  Faq,
  Benefits,
} from '../../../components/common/index';
import {
  EduSurveyCopyMedia,
  EducationPricing,
  CaseStudyTabs,
  EducationFeatureTiers,
  EducationCaseStudyCarousel,
  EducationStats,
} from '../../../components/solutions/education/index';
import {
  ImageCard,
  CaseStudies,
  SolutionsCarouselVideos,
  SolutionsHero,
} from '../../../components/solutions/index';
import { getPageMetadata } from '~/common/meta';

export default Vue.extend({
  components: {
    Benefits,
    CaseStudyTabs,
    NextStep,
    CopyForm,
    EducationFeatureTiers,
    EducationPricing,
    EducationCaseStudyCarousel,
    EducationStats,
    PullQuote,
    FeaturedMedia,
    EduSurveyCopyMedia,
    TabsMenu,
    LinkCards,
    Copy,
    ImageCard,
    CaseStudies,
    SolutionsCallToAction,
    CopyMedia,
    SolutionsCarouselVideos,
    SlpTable,
    Faq,
    SolutionsHero,
  },
  nuxtI18n: false,
  async asyncData({ $content, params, error }: any) {
    try {
      const education = await $content(
        `solutions/education/${params.education ? params.education : 'index'}`,
      ).fetch();
      return { education };
    } catch (e) {
      error({ statusCode: 404 });
      return {};
    }
  },
  head(): MetaInfo {
    return getPageMetadata((this as any).education, this.$route.path);
  },
});
</script>

<template>
  <div class="solutions-wrapper">
    <SlpContainer>
      <component
        :is="component.name"
        v-for="component in education.components"
        :key="component.name"
        :data="component.data"
      />
    </SlpContainer>

    <SlpContainer variant="gradient">
      <NextStep :variant="4" disable-animations />
    </SlpContainer>
  </div>
</template>

<style scoped lang="scss">
.solutions-wrapper {
  overflow: hidden;

  &:deep .slp-container .container,
  &:deep .slp-conatiner .slp-container {
    padding-left: 0;
    padding-right: 0;
  }
}
</style>
